# earc.sml
# demonstrate creating and reading an elliptical arc CAD element

clear();
# create a new file or open existing file
cad C;
GetOutputCAD(C);

# write a elliptical arc
numeric xin = 1000, yin = 2000, xSize = 500, ySize = 300, startAngle = 30;
numeric endAngle = 150, rotation = 45;
CADWriteEllipticalArc(C, 1, xin, yin, xSize, ySize, startAngle, endAngle, rotation);

# the elements are always appended to end of block
# so get number of elements - last element will be our ellipse
numeric lastelem = CADNumElements(C, 1);

# now read ellipse data for most recently added element
numeric radius, sAngle, eAngle, xCenter, yCenter;
CADReadEllipticalArc(C, 1, lastelem, xCenter, yCenter, xSize, ySize, sAngle, eAngle, rotation);
print("write and read CAD elliptical arc");
string a$ = "element  xCenter  yCenter    ";
string b$ = "xSize    ySize   sAngle  eAngle rotation";
print(a$ + b$);
printf("%7d %8.2f %8.2f %8.2f %8.2f %8.2f%8.2f %8.2f \n",
lastelem, xCenter, yCenter, xSize, ySize, sAngle, eAngle, rotation);
CloseCAD(C);