# poly.sml
# demonstrate creating and reading a polygon CAD element
clear();
cad C;
array numeric xPoints[1000];
array numeric yPoints[1000];

GetOutputCAD(C);

# define the polygon (triangle)
xPoints[1] = 0;
yPoints[1] = 0;
xPoints[2] = 100;
yPoints[2] = 0;
xPoints[3] = 50;
yPoints[3] = 100;

numeric numberPoints = 3; # polygon will automatically close to last point
CADWritePoly(C, 1, numberPoints, xPoints, yPoints);

# now read and print out the points
numberPoints = CADReadPoly( C, 1, 1, xPoints, yPoints);

print("polygon point list:\n");
numeric elem;
for elem = 1 to numberPoints {
	printf("%4d %6.2f %6.2f\n", elem, xPoints[elem], yPoints[elem]);
	}
	
CloseCAD(C);